  /* Funkcija ne prima nikakav argument, samo vraca dva varijabilna
     argumenta, ako je izraz korektan prema zadanom regularnom izrazu
       (ab)*.(a)+\$
     Uociti: da bi ucitani niz bio dobar, mora imati barem 2 znaka prije
     znaka za kraj reda.
  */

int regex(int* p_ab, int* p_a)
{
    char kraj = '\n';    /* Kraj niza je prijelaz u novi red. */
    char z, z1;          /* Ucitani znakovi. z1 citamo ako je z <> kraj. */
    int broj_ab = 0;     /* Broj parova (ab) na pocetku. */
    int broj_a = 0;      /* Broj znakova (a) u zavrsnom dijelu. */

        /* Citanje grupacije (ab)*, znaka iza, i jos jednog znaka.
           Korektni izlaz je s break, inace vratimo 0. */
    while (1) {
            /* Ucitavamo prvi znak. Ako je kraj reda, ne valja. */
        scanf("%c", &z);
        if (z == kraj) return 0;
            /* Prvo, odmah u z1 ucitamo i sljedeci znak, a onda testiramo z.
               Ako z nije a, onda sigurno vise nema grupacije (ab)*.
               Ako je z = a, treba paziti, jer a moze biti pocetak/nastavak
               (ab)* ili bilo koji znak kojeg prepoznaje . iz regexa. */
        scanf("%c", &z1);
        if (z == 'a') {
                /* Ako je znak z1 (iza a) kraj reda, ne valja. */
            if (z1 == kraj) return 0;
                /* Provjeri je li z1 jednak b. */
            if (z1 == 'b')
                    /* Ako je, povecamo brojac i nastavljamo petlju. */
                ++broj_ab;
            else
                    /* U protivnom, grupacija je gotova, ucitali smo z = a
                       koji zadovoljava "." iz regexa, i prekidamo petlju.
                       U z1 je vec ucitan sljedeci znak iza a. */
                break;
        }
        else {
                /* Ucitali smo znak z <> a koji zadovoljava "." iz regexa i
                   prekidamo petlju. Znak iza z je vec ucitan u z1. */
            break;
        }
    }

        /* Ovdje mozemo doci samo s break, sto znaci da smo ucitali sve
           parove (ab), znak z iza toga koji zadovoljava ".", i jos jedan znak
           z1 iza toga. Sad provjeravamo z1 i nastavak regexa.
           Svi znakovi do kraja reda moraju biti a i mora biti bar jedan. */

    while (z1 == 'a') {
        ++broj_a;
        scanf("%c", &z1);
    }
    if (z1 <> kraj || broj_a == 0) return 0;

    *p_ab = broj_ab;
    *p_a = broj_a;
    return 1;
}
